package com.giderosmobile.android.plugins.ads.frameworks;

import java.lang.ref.WeakReference;

import android.app.Activity;
import android.util.Log;
import android.util.SparseArray;
import android.view.KeyEvent;

import com.appodeal.ads.Appodeal;
import com.appodeal.ads.BannerCallbacks;
import com.appodeal.ads.InterstitialCallbacks;
import com.appodeal.ads.VideoCallbacks;
import com.giderosmobile.android.plugins.ads.*;

public class AdsAppodeal implements AdsInterface {
	
	private WeakReference<Activity> sActivity;
	private String appKey;
	private String adNetwork = null;
	private int adType = 7;
	private boolean autoCache = true;
	private boolean setTrigger = false;
	private AdsManager mngr;
	static AdsAppodeal me;
	
	public void onCreate(WeakReference<Activity> activity)
	{
		me = this;
		sActivity = activity;
		mngr = new AdsManager();
	}
	
	//on destroy event
	public void onDestroy()
	{	
		mngr.destroy();
	}
	
	public void onStart(){}

	public void onStop(){}
	
	public void onPause(){}
		
	public void onResume(){}
	
	public boolean onKeyUp(int keyCode, KeyEvent event) {
		return false;
	}
	
	public void setKey(final Object parameters){
		SparseArray<String> param = (SparseArray<String>)parameters;
		appKey = param.get(0);
		if (param.size() > 1) {
			adType = Integer.valueOf(param.get(1));
		}
		autoCache = Boolean.valueOf(param.get(2)) != null;
		setTrigger = Boolean.valueOf(param.get(3)) != null;
		adNetwork = param.get(4);
		Appodeal.setAutoCache(adType, autoCache);
		Appodeal.setOnLoadedTriggerBoth(adType, setTrigger);
		Appodeal.disableNetwork(sActivity.get(), adNetwork);
		Appodeal.initialize(sActivity.get(), appKey, adType);
		Appodeal.setInterstitialCallbacks(new InterstitialCallbacks() {
			@Override
			public void onInterstitialShown() {Ads.adDisplayed(this, "interstitial");}
			
			@Override
			public void onInterstitialLoaded(boolean arg0) {Ads.adReceived(this, "interstitial");}
			
			@Override
			public void onInterstitialFailedToLoad() {Ads.adFailed(this, "interstitial", "Failed to receive");}
			
			@Override
			public void onInterstitialClosed() {Ads.adDismissed(this, "interstitial");}
			
			@Override
			public void onInterstitialClicked() {Ads.adActionBegin(this, "interstitial");}
		});
		Appodeal.setVideoCallbacks(new VideoCallbacks() {
			@Override
			public void onVideoShown() {Ads.adDisplayed(this, "video");}
			
			@Override
			public void onVideoLoaded() {Ads.adReceived(this, "video");}
			
			@Override
			public void onVideoFailedToLoad() {Ads.adFailed(this, "video", "Failed to receive");}
			
			@Override
			public void onVideoClosed() {Ads.adDismissed(this, "video");}
			
			@Override
			public void onVideoFinished() {Ads.adActionEnd(this, "video");}
		});
		Appodeal.setBannerCallbacks(new BannerCallbacks() {
			
			@Override
			public void onBannerShown() {Ads.adDisplayed(this, "banner");}
			
			@Override
			public void onBannerLoaded() {Ads.adReceived(this, "banner");}
			
			@Override
			public void onBannerFailedToLoad() {Ads.adFailed(this, "banner", "Failed to receive");}
			
			@Override
			public void onBannerClicked() {Ads.adActionBegin(this, "banner");}
		});
	}
	
	public void loadAd(final Object parameters){
		SparseArray<String> param = (SparseArray<String>)parameters;
		int adType = Integer.valueOf(param.get(0));
		Appodeal.cache(sActivity.get(), adType);
	}
	
	public void showAd(final Object parameters)
	{
		SparseArray<String> param = (SparseArray<String>)parameters;
		int adType = Integer.valueOf(param.get(0));
		Appodeal.show(sActivity.get(), adType);
	}
	
	public void hideAd(String type) {
		int adType = Integer.valueOf(type);
		Appodeal.hide(sActivity.get(), adType);
	}
	
	public int getWidth(){
		return 0;
	}
	
	public int getHeight(){
		return 0;
	}

	@Override
	public void enableTesting() {}
	
}
